// dialog.c: Startup options dialog for Bapple2, using Allegro GUI.

#include <stdio.h>
#include <string.h>

#include <allegro.h>
#include "bapple2.h"
#include "globals.h"

DIALOG the_dialog[] =
{
   /* (dialog proc)     (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
//   { d_clear_proc,      0,    0,    312,  166,    0,    0,    0,    0,       0,    0,    NULL },
   { d_shadow_box_proc, 0,    0,    312,  166,  255,    0,    0,    0,       0,    0,    NULL },
   { d_ctext_proc,      156,  8,    1,    1,    255,    0,    0,    0,       0,    0,    "Bapple2 Options" },
   { d_button_proc,     196,  113,  100,  16,   255,    0,   '\n',  D_EXIT,  0,    0,    "OK" },
   { d_button_proc,     196,  135,  100,  16,   255,    0,    27,   D_EXIT,  0,    0,    "Cancel" },
   { d_text_proc,       168,  33,   17*8, 12,   255,    0,    0,    0,       0,    0,    "Enter your name:" },
   { d_shadow_box_proc, 168,  44,   17*8+4, 12, 255,    0,    0,    0,       0,    0,    NULL },
   { d_edit_proc,       170,  46,   17*8, 12,   255,    0,    0,    0,      16,    0,    player.name },
   { d_check_proc,      4,    30,   144,  12,   255,    0,    'b',  0,       0,    0,    "Double &Buffering" },
   { d_check_proc,      4,    44,   80,   12,   255,    0,    'n',  0,       0,    0,    "&No Sound" },
   { d_check_proc,      4,    58,   144,  12,   255,    0,    'j',  0,       0,    0,    "&Joystick Support" },
   { d_check_proc,      4,    72,   128,  12,   255,    0,    's',  0,       0,    0,    "Window &Sliding" },
   { d_check_proc,      4,    86,   160,  12,   255,    0,    'a',  0,       0,    0,    "&Classic Controls" },
//   { d_check_proc,      4,    100,  88,   12,   255,    0,    'm',  0,       0,    0,    "Large &Map" },
   { NULL,              0,    0,    0,    0,      0,    0,    0,    0,       0,    0,    NULL }
};

void options_dialog(void)
{
	FILE *fp;
	int i;

	fp = fopen("bapple2.cfg", "r");
	if (!fp)
		player.name[0] = '\0';
	else
	{
		fgets(player.name, 15, fp);
		fclose(fp);
	}

	gui_fg_color = makecol(0, 0, 0);
	gui_bg_color = makecol(255, 255, 255);
//	gui_fg_color = 0;
//	gui_bg_color = 255;
	set_dialog_color(the_dialog, gui_fg_color, gui_bg_color);
    centre_dialog(the_dialog);
	do_dialog(the_dialog, -1);

#ifndef WIN32
	// Double buffering vs page flipping
	if (the_dialog[7].flags & D_SELECTED)
		gfx_method = 1;
#endif

	// Sound or no sound?
	sound_on = !(the_dialog[8].flags & D_SELECTED);
	if (!sound_on)
		remove_sound();

	// Joystick support
	joystick_on = the_dialog[9].flags & D_SELECTED;
	if (joystick_on)
		if (initialise_joystick())
			joystick_on = 0;

	// Viewport sliding
	slide_enabled = the_dialog[10].flags & D_SELECTED;

	// Normal input (SubSpace) vs classic input (Herzog Zwei)
	alt_input = the_dialog[11].flags & D_SELECTED;

	// Display the big mini-map in the normal game view
//	use_big_map = the_dialog[9].flags & D_SELECTED;

	// Write the player name out to bapple2.cfg
	fp = fopen("bapple2.cfg", "w");
	if (fp)
	{
		fputs(player.name, fp);
		fclose(fp);
	}

	for (i = 0; i < strlen(player.name); i++)
		if (player.name[i] == '%')
			player.name[i] = '*';
}
